(* we multiply by π here *)


let unicode = "∀ ∃ ∆ ∇ π Ш"

let rec eval env = function
  | Num i -> i
  | Var x -> List.assoc x env
  | Let (x, e1, in_e2) ->
      let val_x = eval env e1 in
      eval ((x, val_x) :: env) in_e2
  | Binop (op, e1, e2) ->
      let v1 = eval env e1 in
      let v2 = eval env e2 in
      eval_op op v1 v2
and eval_op op v1 v2 =
  match op with
    | "+" -> v1 + v2
    | "-" -> v1 - v2
    | "*" -> v1 * v2
    | "/" -> v1 / v2
    | _   -> failwith ("Unknown operator: " ^ op);;
